:host {
  user-select: none;
  -webkit-tap-highlight-color: transparent;
  border: none;
  padding: 0;
  background: transparent;

  &[disabled] {
    opacity: 0.5;
  }

  &:focus {
    outline: none;
  }

  &:active {
    border: none;
  }
}

:host:not(.no-style) {
  background-color: var(--app-button);
  box-shadow: 5px 4px 0 var(--app-button-shadow);
  color: var(--app-button-text);
  border-radius: 16px;
  display: flex;
  font-family: var(--primary-font);
  font-size: var(--primary-font-size);
  user-select: none;
  -webkit-tap-highlight-color: transparent;
  position: relative;
  text-align: center;
  transition: background-color 330ms linear, box-shadow 330ms linear, color 330ms linear;

  .text-content {
    width: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    padding: var(--spacing) var(--spacing);
    position: relative;
    min-width: 0;
    font-size: inherit;
    min-height: inherit;
    box-sizing: border-box;

    @media screen and (min-width: 414px) {
      padding: var(--spacing) var(--spacing-big);
    }
  }

  &.small {
    font-size: var(--primary-font-size-small);

    .text-content {
      padding: var(--spacing) var(--spacing);
    }
  }

  &.very-small {
    font-size: var(--primary-font-size-very-small);

    .text-content {
      padding: var(--spacing) var(--spacing-medium);
    }
  }

  &.extra-small {
    font-size: var(--primary-font-size-extra-small);

    .text-content {
      padding: var(--spacing) var(--spacing);
    }
  }

  &.fw-normal {
    font-weight: normal;
  }

  &::before {
    content: "";
    top: 0;
    left: 0;
    position: absolute;
    width: 100%;
    height: 100%;
    border-radius: inherit;
    z-index: 0;
    opacity: 0.3;
    background-color: transparent;
    transition: all 220ms linear;
  }

  &:focus::before {
    background-color: var(--app-button-shadow);
  }

  &.no-shadow {
    box-shadow: unset !important;
  }

  &[href] {
    &,
    &:visited,
    &:link {
      color: var(--app-button-text);
      text-decoration: none;
    }
  }

  &.circle {
    width: 60px;
    height: 60px;
    border-radius: 50%;

    .text-content {
      padding: 0;
      height: 100%;
    }

    &.small {
      width: 42px;
      height: 42px;
      box-shadow: 2px 2px 0 var(--app-button-shadow);
    }

    &.very-small {
      width: 34px;
      height: 34px;
      box-shadow: 2px 2px 0 var(--app-button-shadow);
    }
  }

  &.no-background {
    background: transparent !important;
  }

  &.small-padding {
    .text-content {
      padding: var(--spacing-small) var(--spacing);
    }
  }

  &.alternate-ff {
    font-family: var(--secondary-font);
    font-size: var(--secondary-font-size);
  }
}
